--[[/*
	Titan [Poison] v 1.0 original Titan Panel Poison
	An addon for World of Warcraft that shows information about
	trade items in Titan Panel.
	Programed By Medyn 28-01-2007 (c)
	Medyn medyn@volny.cz Tabor/Czech Republic

	License:
		This program is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License
		as published by the Free Software Foundation; either version 2
		of the License, or (at your option) any later version.

		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
		GNU General Public License for more details.
*/
]]



TITAN_POISON_ID = "Poison";
TITAN_POISON_PLAYER_CLASS = "";
local p, TITAN_POISON_PLAYER_CLASS = UnitClass("player");


function TitanPanelPoisonButton_OnLoad()
	local tooltipAboutText;

	SLASH_TOVERSION1 = "/tp"
	SLASH_TOVERSION2 = "/tphelp"
	SlashCmdList["TOVERSION"] = function(msg) ShowAllUnitBuffsAndDebuffs() end
	

	TitanPanelOre_Print(TITAN_POISON_LOCAL_NAME.." "..TITAN_POISON_VERSION.." loaded!");

	tooltipAboutText = "|cffff8020"..TITAN_POISON_LOCAL_NAME.." "..TitanUtils_GetGreenText(TITAN_POISON_VERSION).."\n";

	this.registry = {
		id = TITAN_POISON_ID,
		menuText = TITAN_POISON_LOCAL_NAME,
		buttonTextFunction = "TitanPanelPoisonButton_GetButtonText",
		tooltipTitle = tooltipAboutText,
		category = "Information",
		tooltipTextFunction = nil,
		icon = "Interface\\Addons\\TitanPoison\\Artwork\\TitanPoison",
		frequency = 1.0,
		iconWidth = 16,
		updateType = TITAN_PANEL_UPDATE_BUTTON,
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
			ShowColoredText = 1,
		}
	};
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		this:RegisterEvent("PLAYER_LEAVING_WORLD");
end

-- Bouton
function TitanPanelPoisonButton_GetButtonText()

	local txtTitanTitle = " ";
	local hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges = GetWeaponEnchantInfo();

	if hasMainHandEnchant then
      local mhp = FormatTime(mainHandExpiration/1000);

    	local m = floor((mainHandExpiration/1000)/60);
	    local s = floor(mainHandExpiration/1000) - (m*60);

      if m < 5 and s >58 then
        PlaySound("LEVELUPSOUND");
        Poison_Print("Main hand poison will expired!");
      end

			txtTitanTitle = txtTitanTitle.." "..TITAN_POISON_YELLOW.."MH:"..mhp;
	else
			txtTitanTitle = txtTitanTitle.." "..TITAN_POISON_YELLOW.."MH:--";
  	end

	if hasOffHandEnchant then
    	local ohp = FormatTime(offHandExpiration/1000);
      
    	local mm = floor((offHandExpiration/1000)/60);
	    local ss = floor(offHandExpiration/1000) - (mm*60);

    	if mm < 5 and ss >58 then
        	PlaySound("LEVELUPSOUND");
        	Poison_Print("Offhand poison will expired!");
      	end
      
			txtTitanTitle = txtTitanTitle.." "..TITAN_POISON_YELLOW.."OH:"..ohp;
		
  	else
 			txtTitanTitle = txtTitanTitle.." "..TITAN_POISON_YELLOW.."OH:--";
   	end



	return TITAN_POISON_LOCAL_NAME, txtTitanTitle;
end

-- Tooltip
function TitanPanelPoisonButton_GetTooltipText()
	local tooltipText = "";

	return tooltipText;
end

function FormatTime(t)
	local m = floor(t/60)
	local s = t - (m*60)
	if m > 0 then
		timetext = TITAN_POISON_GREEN..m..":"..floor(s);
	else
		timetext = TITAN_POISON_RED..floor(s).."s";
	end

  return timetext
end



-- Event
function TitanPanelPoisonButton_OnEvent()

	local message;
		if (event == "PLAYER_LEAVING_WORLD") then
		end
		if (event == "PLAYER_ENTERING_WORLD") then
		end
		TitanPanelButton_UpdateButton(TITAN_POISON_ID);
end

-- Menu
function TitanPanelRightClickMenu_PreparePoisonMenu()
	local info;

	TitanPanelRightClickMenu_AddToggleIcon(TITAN_POISON_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_POISON_ID);
 	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_POISON_ID, TITAN_PANEL_MENU_FUNC_HIDE);

	-- info about plugin
	info = {};
	info.text = TITAN_POISON_ABOUT_TEXT;
	info.value = "DisplayAbout";
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

end

function Poison_Print(text)
	if (text) then
      DEFAULT_CHAT_FRAME:AddMessage(TITAN_POISON_RED.."------------------------------------------------");
      DEFAULT_CHAT_FRAME:AddMessage(TITAN_POISON_RED..text);
      DEFAULT_CHAT_FRAME:AddMessage(TITAN_POISON_RED.."------------------------------------------------");
  end
end
